## mingw-w64-openexr-3.3.3-2.src.tar.zst

=== src/lib/OpenEXR/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright (c) Contributors to the OpenEXR Project.

openexr_define_library(OpenEXR
  PRIV_EXPORT OPENEXR_EXPORTS
  CURDIR ${CMAKE_CURRENT_SOURCE_DIR}
  SOURCES
    ImfAutoArray.h
    ImfB44Compressor.h
    ImfCheckedArithmetic.h
    ImfCompression.h
    ImfCompressor.h
    ImfDwaCompressor.h
    ImfFastHuf.h
    ImfInputPartData.h
    ImfInputStreamMutex.h
    ImfMisc.h
    ImfOptimizedPixelReading.h
    ImfOutputPartData.h
    ImfOutputStreamMutex.h
    ImfPizCompressor.h
    ImfPxr24Compressor.h
    ImfRle.h
    ImfRleCompressor.h
    ImfScanLineInputFile.h
    ImfSimd.h
    ImfSystemSpecific.h
    ImfTileOffsets.h
    ImfTiledMisc.h
    ImfZip.h
    ImfZipCompressor.h
    ImfAcesFile.cpp
    ImfAttribute.cpp
    ImfB44Compressor.cpp
    ImfBoxAttribute.cpp
    ImfChannelList.cpp
    ImfChannelListAttribute.cpp
    ImfChromaticities.cpp
    ImfChromaticitiesAttribute.cpp
    ImfCompositeDeepScanLine.cpp
    ImfCompressionAttribute.cpp
    ImfCompressor.cpp
    ImfCompression.cpp
    ImfContext.cpp
    ImfContextInit.cpp
    ImfConvert.cpp
    ImfCRgbaFile.cpp
    ImfDeepCompositing.cpp
    ImfDeepFrameBuffer.cpp
    ImfDeepImageStateAttribute.cpp
    ImfDeepScanLineInputFile.cpp
    ImfDeepScanLineInputPart.cpp
    ImfDeepScanLineOutputFile.cpp
    ImfDeepScanLineOutputPart.cpp
    ImfDeepTiledInputFile.cpp
    ImfDeepTiledInputPart.cpp
    ImfDeepTiledOutputFile.cpp
    ImfDeepTiledOutputPart.cpp
    ImfDoubleAttribute.cpp
    ImfDwaCompressor.cpp
    ImfEnvmap.cpp
    ImfEnvmapAttribute.cpp
    ImfFastHuf.cpp
    ImfFloatAttribute.cpp
    ImfFloatVectorAttribute.cpp
    ImfFrameBuffer.cpp
    ImfFramesPerSecond.cpp
    ImfGenericInputFile.cpp
    ImfGenericOutputFile.cpp
    ImfHeader.cpp
    ImfHuf.cpp
    ImfIDManifest.cpp
    ImfIDManifestAttribute.cpp
    ImfInputFile.cpp
    ImfInputPart.cpp
    ImfInputPartData.cpp
    ImfIntAttribute.cpp
    ImfIO.cpp
    ImfKeyCode.cpp
    ImfKeyCodeAttribute.cpp
    ImfLineOrderAttribute.cpp
    ImfLut.cpp
    ImfMatrixAttribute.cpp
    ImfMisc.cpp
    ImfMultiPartInputFile.cpp
    ImfMultiPartOutputFile.cpp
    ImfMultiView.cpp
    ImfOpaqueAttribute.cpp
    ImfOutputFile.cpp
    ImfOutputPart.cpp
    ImfOutputPartData.cpp
    ImfPartType.cpp
    ImfPizCompressor.cpp
    ImfPreviewImage.cpp
    ImfPreviewImageAttribute.cpp
    ImfPxr24Compressor.cpp
    ImfRational.cpp
    ImfRationalAttribute.cpp
    ImfRgbaFile.cpp
    ImfRgbaYca.cpp
    ImfRle.cpp
    ImfRleCompressor.cpp
    ImfScanLineInputFile.cpp
    ImfStandardAttributes.cpp
    ImfStdIO.cpp
    ImfStringAttribute.cpp
    ImfStringVectorAttribute.cpp
    ImfSystemSpecific.cpp
    ImfTestFile.cpp
    ImfThreading.cpp
    ImfTileDescriptionAttribute.cpp
    ImfTiledInputFile.cpp
    ImfTiledInputPart.cpp
    ImfTiledMisc.cpp
    ImfTiledOutputFile.cpp
    ImfTiledOutputPart.cpp
    ImfTiledRgbaFile.cpp
    ImfTileOffsets.cpp
    ImfTimeCode.cpp
    ImfTimeCodeAttribute.cpp
    ImfVecAttribute.cpp
    ImfVersion.cpp
    ImfWav.cpp
    ImfZip.cpp
    ImfZipCompressor.cpp
  HEADERS
    ImfAcesFile.h
    ImfArray.h
    ImfAttribute.h
    ImfBoxAttribute.h
    ImfChannelList.h
    ImfChannelListAttribute.h
    ImfChromaticities.h
    ImfChromaticitiesAttribute.h
    ImfCompositeDeepScanLine.h
    ImfCompression.h
    ImfCompressionAttribute.h
    ImfCompressor.h
    ImfContext.h
    ImfContextInit.h
    ImfConvert.h
    ImfCRgbaFile.h
    ImfDeepCompositing.h
    ImfDeepFrameBuffer.h
    ImfDeepImageState.h
    ImfDeepImageStateAttribute.h
    ImfDeepScanLineInputFile.h
    ImfDeepScanLineInputPart.h
    ImfDeepScanLineOutputFile.h
    ImfDeepScanLineOutputPart.h
    ImfDeepTiledInputFile.h
    ImfDeepTiledInputPart.h
    ImfDeepTiledOutputFile.h
    ImfDeepTiledOutputPart.h
    ImfDoubleAttribute.h
    ImfEnvmap.h
    ImfEnvmapAttribute.h
    ImfExport.h
    ImfFloatAttribute.h
    ImfFloatVectorAttribute.h
    ImfForward.h
    ImfFrameBuffer.h
    ImfFramesPerSecond.h
    ImfGenericInputFile.h
    ImfGenericOutputFile.h
    ImfHeader.h
    ImfHuf.h
    ImfIDManifest.h
    ImfIDManifestAttribute.h
    ImfInputFile.h
    ImfInputPart.h
    ImfInt64.h
    ImfIntAttribute.h
    ImfIO.h
    ImfKeyCode.h
    ImfKeyCodeAttribute.h
    ImfLineOrder.h
    ImfLineOrderAttribute.h
    ImfLut.h
    ImfMatrixAttribute.h
    ImfMisc.h
    ImfMultiPartInputFile.h
    ImfMultiPartOutputFile.h
    ImfMultiView.h
    ImfName.h
    ImfNamespace.h
    ImfOpaqueAttribute.h
    ImfOutputFile.h
    ImfOutputPart.h
    ImfPartHelper.h
    ImfPartType.h
    ImfPixelType.h
    ImfPreviewImage.h
    ImfPreviewImageAttribute.h
    ImfRational.h
    ImfRationalAttribute.h
    ImfRgba.h
    ImfRgbaFile.h
    ImfRgbaYca.h
    ImfStandardAttributes.h
    ImfStdIO.h
    ImfStringAttribute.h
    ImfStringVectorAttribute.h
    ImfTestFile.h
    ImfThreading.h
    ImfTileDescription.h
    ImfTileDescriptionAttribute.h
    ImfTiledInputFile.h
    ImfTiledInputPart.h
    ImfTiledOutputFile.h
    ImfTiledOutputPart.h
    ImfTiledRgbaFile.h
    ImfTimeCode.h
    ImfTimeCodeAttribute.h
    ImfVecAttribute.h
    ImfVersion.h
    ImfWav.h
    ImfXdr.h
  DEPENDENCIES
    Imath::Imath
    OpenEXR::Config
    OpenEXR::Iex
    OpenEXR::IlmThread
    OpenEXR::OpenEXRCore
  )

=== src/test/bin/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# Copyright (c) Contributors to the OpenEXR Project.

if(BUILD_TESTING)

  find_package(Python3 COMPONENTS Interpreter)
  if (NOT Python3_FOUND)
    message(STATUS "Python3 not found: skipping bin tests")
    return()
  endif()

  message(STATUS "adding bin tests")

  set(OPENEXR_IMAGES_REPO "https://raw.githubusercontent.com/AcademySoftwareFoundation/openexr-images" CACHE STRING
    "Bin test Image repo")

  set(OPENEXR_IMAGES_TAG "v1.0" CACHE STRING "Bin test image repo tag")

  if ("${OPENEXR_IMAGES_TAG}" STREQUAL "")
    set(images_url ${OPENEXR_IMAGES_REPO})
  else()
    set(images_url ${OPENEXR_IMAGES_REPO}/${OPENEXR_IMAGES_TAG})
  endif()

  set(images
      TestImages/GrayRampsHorizontal.exr
      LuminanceChroma/Garden.exr
      MultiResolution/ColorCodedLevels.exr
      MultiResolution/WavyLinesLatLong.exr
      MultiResolution/WavyLinesCube.exr
      LuminanceChroma/Flowers.exr
      MultiView/Adjuster.exr
      Chromaticities/Rec709_YC.exr
      Chromaticities/Rec709.exr
      Chromaticities/XYZ_YC.exr
      Chromaticities/XYZ.exr
      TestImages/GammaChart.exr
      Beachball/singlepart.0001.exr
      v2/LeftView/Balls.exr
      v2/Stereo/Trunks.exr
      Beachball/multipart.0001.exr
  )

  foreach(image ${images})
    if (NOT EXISTS ${CMAKE_CURRENT_BINARY_DIR}/${image})
      message(STATUS "Downloading ${images_url}/${image}")
      file(DOWNLOAD ${images_url}/${image} ${CMAKE_CURRENT_BINARY_DIR}/${image})
    endif()
  endforeach()

  add_test(NAME OpenEXR.bin.exrinfo
           COMMAND ${Python3_EXECUTABLE}
           ${CMAKE_CURRENT_SOURCE_DIR}/test_exrinfo.py
           $<TARGET_FILE:exrinfo> ${CMAKE_CURRENT_BINARY_DIR} ${OPENEXR_VERSION})

  add_test(NAME OpenEXR.bin.exrheader
           COMMAND ${Python3_EXECUTABLE}
           ${CMAKE_CURRENT_SOURCE_DIR}/test_exrheader.py
           $<TARGET_FILE:exrheader> ${CMAKE_CURRENT_BINARY_DIR} ${OPENEXR_VERSION})

  set(tests
      exr2aces
      exrenvmap
      exrmakepreview
      exrmaketiled
      exrmanifest
      exrmultiview
      exrmultipart
      exrstdattr
      exrmetrics
  )

  foreach(test ${tests})
    add_test(NAME OpenEXR.bin.${test}
           COMMAND ${Python3_EXECUTABLE}
           ${CMAKE_CURRENT_SOURCE_DIR}/test_${test}.py
           $<TARGET_FILE:${test}> $<TARGET_FILE:exrinfo>
           ${CMAKE_CURRENT_BINARY_DIR} ${OPENEXR_VERSION})
  endforeach()

  # run exrcheck on all images
  add_test(NAME OpenEXR.bin.exrcheck
           COMMAND ${Python3_EXECUTABLE}
           ${CMAKE_CURRENT_SOURCE_DIR}/test_exrcheck.py
           $<TARGET_FILE:exrcheck>
           ${CMAKE_CURRENT_BINARY_DIR}
           ${images})

endif()

=== PKGBUILD ===
# Maintainer: Alexey Pavlov <alexpux@gmail.com>

_realname=openexr
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.3.3
pkgrel=2
pkgdesc='A high dynamic-range image file format library (mingw-w64)'
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://www.openexr.com/"
msys2_repository_url='https://github.com/AcademySoftwareFoundation/openexr'
msys2_references=(
  "purl: pkg:pypi/openexr"
  "cpe: cpe:/a:ilm:openexr"
  "cpe: cpe:/a:openexr:openexr"
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-imath"
         "${MINGW_PACKAGE_PREFIX}-libdeflate"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
conflicts=(
  "${MINGW_PACKAGE_PREFIX}-ilmbase"
  "${MINGW_PACKAGE_PREFIX}-pyilmbase"
)
replaces=(
  "${MINGW_PACKAGE_PREFIX}-ilmbase"
  "${MINGW_PACKAGE_PREFIX}-pyilmbase"
)
source=("https://github.com/openexr/openexr/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        0006-cmake-soversion.patch
        0007-export-TypedAttribute-value.patch
        "https://github.com/AcademySoftwareFoundation/openexr/pull/2011.patch")
sha256sums=('0ffbd842a7ee2128d44affdea30f42294b4061293cde3aa75b61a53573413d1e'
            '5653da878ebbf5f3087bb529213931b48e151aef082b34e19d189e22be0411e7'
            '204777b48cde1c4d390789f10c5e429d5295be701f68a7937a90d0ecf271c048'
            'e88b851dafb7ecb34b8dce94b8f935cab6b3e1821a56289f6ea1ae0650361bdd')

# Helper macros to help make tasks easier #
apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying $_patch"
    patch -Np1 -i "${srcdir}/$_patch"
  done
}

prepare(){
  cd "${srcdir}/${_realname}-${pkgver}"

  # https://github.com/AcademySoftwareFoundation/openexr/pull/2011
  apply_patch_with_msg \
    0006-cmake-soversion.patch \
    0007-export-TypedAttribute-value.patch \
    2011.patch
}

build() {
  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CXXFLAGS+=" -Wno-ignored-attributes"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      ${extra_config[@]} \
      -DBUILD_SHARED_LIBS=ON \
      -DBUILD_TESTING=OFF \
      -DOPENEXR_BUILD_EXAMPLES=OFF \
      -S "${_realname}-${pkgver}" \
      -B "build-${MSYSTEM}"

  cmake --build "build-${MSYSTEM}"
}

check() {
  cd "${srcdir}/build-${MSYSTEM}"
  ${MINGW_PREFIX}/bin/cmake -DBUILD_TESTING=ON ../${_realname}-${pkgver}
  ${MINGW_PREFIX}/bin/cmake --build .
  ${MINGW_PREFIX}/bin/ctest.exe ./ || true
}

package() {
  DESTDIR="${pkgdir}" cmake --install "build-${MSYSTEM}"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE.md" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE.md"
}
